﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace adx_ol_cs_ExtendedMAPI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            adxmapiStoreAccessor1.Initialize(true);
            AddinExpress.MAPI.Folder container = adxmapiStoreAccessor1.MsgStores[0].RootFolder.Folders[1];
            foreach (AddinExpress.MAPI.Folder folder in container.Folders)
            {
                cboFolders.Items.Add(folder.GetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_DISPLAY_NAME));
            }
            cboFolders.SelectedIndex = 0;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            adxmapiStoreAccessor1.LogOff();
        }

        private void cboFolders_SelectedIndexChanged(object sender, EventArgs e)
        {
            lbItems.BeginUpdate();
            lbItems.Items.Clear();
            AddinExpress.MAPI.Folder selectedFolder = adxmapiStoreAccessor1.MsgStores[0].RootFolder.Folders[1].Folders[cboFolders.SelectedIndex];
            foreach (AddinExpress.MAPI.MapiItem item in selectedFolder.HiddenMapiItems)
            {
                lbItems.Items.Add(item.GetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_MESSAGE_CLASS));
            }
            lbItems.EndUpdate();
        }

        private void btnCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();
            AddinExpress.MAPI.Folder selectedFolder = adxmapiStoreAccessor1.MsgStores[0].RootFolder.Folders[1].Folders[cboFolders.SelectedIndex];
            AddinExpress.MAPI.MapiItem hiddenItem = selectedFolder.HiddenMapiItems.Add();
            hiddenItem.SetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_DISPLAY_NAME, "My first hidden item");
            hiddenItem.SetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_MESSAGE_CLASS, rnd.Next(1000).ToString());
            cboFolders_SelectedIndexChanged(this, EventArgs.Empty);
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {
            if (lbItems.SelectedIndex > -1)
            {
                AddinExpress.MAPI.Folder selectedFolder = adxmapiStoreAccessor1.MsgStores[0].RootFolder.Folders[1].Folders[cboFolders.SelectedIndex];
                selectedFolder.HiddenMapiItems.Remove(lbItems.SelectedIndex);
            }
            cboFolders_SelectedIndexChanged(this, EventArgs.Empty);
        }
    }
}
